package org.bench4q.agent.test.scenario;

import static org.junit.Assert.*;

import java.util.UUID;
import java.util.concurrent.TimeUnit;

import org.bench4q.agent.scenario.Scenario;
import org.bench4q.agent.scenario.ScenarioContext;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration(locations = { "classpath:application-context.xml" })
public class Test_ScenarioContext {

	@Test
	public void testBuildScenarioContext() {
		ScenarioContext context = ScenarioContext.buildScenarioContext(
				UUID.randomUUID(), new Scenario(), 20);
		assertEquals(10,
				context.getExecutor().getKeepAliveTime(TimeUnit.MINUTES));
		assertEquals(20, context.getExecutor().getMaximumPoolSize());
	}

	// @Test
	// public void testForParameterization() throws IOException {
	// RunScenarioModel model = Test_HBasePlugin.buildScenario(10);
	// String param_name = "param1";
	// UUID testId = UUID.randomUUID();
	//
	// createParamFileAndFillParamContent(param_name, testId);
	//
	// model.getDefinedParameters().add(
	// new DefinedParameterModel(param_name, "Para_Table",
	// PickOrder.SEQUENTIAL.name(),
	// UpdateStrategy.EACH_OCCURRENCE.name()));
	//
	// ScenarioContext scenarioContext = ScenarioContext.buildScenarioContext(
	// testId, Scenario.scenarioBuilderWithCompile(model), 10);
	//
	// VUser vUser = new VUser(scenarioContext, 1);
	// String firstValue = vUser.getParam(param_name);
	// String secondValue = vUser.getParam(param_name);
	// assertNotEquals(firstValue, secondValue);
	// }

	// private void createParamFileAndFillParamContent(String param_name,
	// UUID testId) throws IOException {
	// File parmFile = new File(
	// new Para_Table(testId, PickOrder.SEQUENTIAL,
	// UpdateStrategy.EACH_ITERATION, param_name, -1)
	// .getParamFileFullPath(param_name));
	// TestHelper.createFileIfNotExist(parmFile);
	// FileUtils.writeStringToFile(parmFile,
	// "row1;10;11~row2;20;21~row3,30,31~");
	// }
}
