package org.bench4q.agent.test.scenario;

import static org.junit.Assert.*;

import java.util.ArrayList;
import java.util.UUID;

import org.bench4q.agent.scenario.Scenario;
import org.bench4q.agent.scenario.ScenarioContext;
import org.bench4q.agent.scenario.ScenarioEngine;
import org.bench4q.agent.test.TestBase;
import org.bench4q.share.models.agent.ParameterModel;
import org.bench4q.share.models.agent.scriptrecord.BehaviorModel;
import org.bench4q.share.models.agent.scriptrecord.UsePluginModel;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration(locations = { "classpath:application-context.xml" })
public class Test_ScenarioEngine extends TestBase {
	private ScenarioEngine scenarioEngine;

	private ScenarioEngine getScenarioEngine() {
		return scenarioEngine;
	}

	@Autowired
	private void setScenarioEngine(ScenarioEngine scenarioEngine) {
		this.scenarioEngine = scenarioEngine;
	}

	@Test
	public void test_UpdatePopulation() {
		UUID testId = UUID.randomUUID();
		ScenarioContext scenarioContext = ScenarioContext
				.buildScenarioContext(
						testId,
						Scenario.scenarioBuilderWithCompile(buildRunScenarioModelWith(
								new ArrayList<UsePluginModel>(),
								BehaviorModel
										.UserBehaviorBuilder(1, "ok", "http",
												new ArrayList<ParameterModel>()))),
						100);
		this.getScenarioEngine().getRunningTests().put(testId, scenarioContext);
		this.getScenarioEngine().updatePopulation(testId, 20);
		assertEquals(20, scenarioContext.getExecutor().getMaximumPoolSize());
		System.out.println(scenarioContext.getExecutor().getActiveCount());
	}
}
