package org.bench4q.recorder.httpcapture.generator;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.zip.GZIPInputStream;

public class GzipDecoder extends ContentDecoder {

	public byte[] decodeContent(InputStream inputStream) {
		try {
			GZIPInputStream gzipInputStream = new GZIPInputStream(inputStream);
			ByteArrayOutputStream outputStream = new ByteArrayOutputStream();

			byte[] buf = new byte[1024];
			int len;
			while ((len = gzipInputStream.read(buf)) > 0) {
				outputStream.write(buf, 0, len);
			}
			return outputStream.toByteArray();
		} catch (IOException e) {
			logger.error("decodeContent", e);
			return null;
		}
	}
}
