package org.bench4q.recorder;

import java.io.File;
import java.io.IOException;
import java.io.UnsupportedEncodingException;

import org.apache.commons.io.FileUtils;
import org.bench4q.recorder.httpcapture.generator.ResponseHeader;
import org.bench4q.recorder.httpcapture.generator.ResponseParser;
import org.junit.Test;

import static org.junit.Assert.*;

public class TestResponseParser {
	private ResponseParser responseParser;
	private static String FILE_SEPARATOR = System.getProperty("file.separator");

	private ResponseParser getResponseParser() {
		return responseParser;
	}

	private void setResponseParser(ResponseParser responseParser) {
		this.responseParser = responseParser;
	}

	public TestResponseParser() throws IOException {
		byte[] response = FileUtils.readFileToByteArray(new File(
				"RecordScriptTestCase" + FILE_SEPARATOR
						+ "gzipBaiduResponse.txt"));
		this.setResponseParser(new ResponseParser(response));
	}

	@Test
	public void testParseResponseHeader() throws Exception {
		ResponseHeader parseResponseHeader = this.getResponseParser()
				.getResponseHeader();
		assertEquals(parseResponseHeader.getContentLength(), 12852);
		assertEquals(parseResponseHeader.getCharset(), "utf-8");
		assertEquals(parseResponseHeader.getContentEncoding(), "gzip");
		assertEquals(parseResponseHeader.getContentType(), "text/html");
		assertEquals(parseResponseHeader.getRespCode(), "200");
	}

	@Test
	public void testParseResponseBody() throws UnsupportedEncodingException {
		String responseBody = this.getResponseParser().getResponseBody();
		assertTrue(responseBody.indexOf("我的") > -1);
	}
}
