var behaviors = new Array();
var usePluginList = new Array();
var pageList = new Array();
function submit(selectedNode) {
	var scriptName = $(selectedNode.parentNode.parentNode).find("input").val();
	saveBehaviorInfo();
	savePluginInfo();
	if (validateBehaviors(behaviors)) {
		submitScriptWithScriptName(scriptName);
	}
}

function saveBehaviorInfo() {
	var children = document.getElementById("showPluginMethod").childNodes;
	var length = children.length;
	if (length != 0) {
		saveParamInfoWithSubmit(children, length, "behavior");
	}
}

function savePluginInfo() {
	var pluginChildren = document.getElementById("pluginParams").childNodes;
	var pluginLength = pluginChildren.length;
	if (pluginLength != 0) {
		saveParamInfoWithSubmit(pluginChildren, pluginLength, "plugin");
	}
}

function validateBehaviors(behaviors) {
	return (behaviors.length != 0 || behaviors != null);
}

function saveParamInfoWithSubmit(children, length, type) {
	for ( var i = 0; i < length; i++) {
		for ( var j = 0; j < length; j++) {
			var node = children[j];
			if ($(node).attr("id") == i) {
				if (type == "behavior") {
					saveABehavior(node);
				} else if (type == "plugin") {
					saveAPlugin(node);
				}
				break;
			}
		}
	}
}

function saveAPlugin(node) {
	var id = node.firstChild.firstChild.nodeValue;
	var name = id.split("_")[0];
	var div = node.lastChild.lastChild.childNodes;
	var parameters = saveParamInfo(div);
	var usePluginModel = new UsePluginModel(id, name, parameters);
	usePluginList.push(usePluginModel);
}

function saveABehavior(node) {
	var div = node.lastChild.lastChild.childNodes;
	var behaviorIndex = 0;
	var use = "", name = "", type = "";
	var plugin_method = node.firstChild.firstChild.nodeValue.split(".");
	name = plugin_method[1];
	use = plugin_method[0];
	if (use.split("_")[0] == "ConstantTimer") {
		type = "TIMERBEHAVIOR";
	} else {
		type = "USERBEHAVIOR";
	}
	var parameters = saveParamInfo(div);
	var behaviorModel = new BehaviorModel(behaviorIndex, use, name, type,
			parameters);
	behaviors.push(behaviorModel);
}

// 封装到parameters中，保存参数
function saveParamInfo(div) {
	var length = div.length;
	var parameters = new Array();
	for ( var i = 0; i < length; i++) {
		var node = div[i];
		var parameterModel;
		var key = "", value = "", temp = "";
		if ($(node).attr("class") == "Field sample_frame") {
			key = node.lastChild.firstChild.nodeValue;
			temp = $(node).find("input").val();
			if (temp != "") {
				value = temp;
			}
		} else if ($(node).attr("class") == "NField sample_frame") {
			key = node.firstChild.firstChild.nodeValue.split(":")[0];
			var fieldNode = $(node).find("table").children();
			var fieldLength = $(fieldNode).length;
			for ( var j = 0; j < fieldLength; j++) {
				temp = $(fieldNode[j]).find("input").val();
				if (temp != "") {
					value += temp;
				}
				if (j != fieldLength - 1) {
					value += ";";
				}
			}
		} else if ($(node).attr("class") == "Table sample_frame") {
			key = node.lastChild.firstChild.nodeValue;
			var table = $(node).find("table");
			var col = table.find("th").length;
			var row = table.find("tbody").children().length;
			var tbody = $(node).find("tbody");
			for ( var m = 0; m < row; m++) {
				for ( var n = 0; n < col; n++) {
					var rowNode = $(tbody).children()[m];
					var colNode = $(rowNode).children()[n];
					temp = $(colNode).find("input").val();
					if (temp != "") {
						value += temp + "|";
					}
				}
				if (value != "") {
					value += ";";
				}
			}
		} else if ($(node).attr("class") == "CheckBox sample_frame") {
			key = node.lastChild.firstChild.nodeValue;
			$('input[name= "checkbox"]:checked').each(function() {
				temp = $(this).val();
				if (temp != "") {
					value += temp + ";";
				}
			});
		} else if ($(node).attr("class") == "RadioButton sample_frame") {
			key = node.lastChild.firstChild.nodeValue;
			temp = $('input[name="radio"]:checked').val();
			if (temp != "") {
				value += temp + ";";
			}
		}
		if (value != "") {
			parameterModel = new ParameterModel(key, value);
			parameters.push(parameterModel);
		}
	}
	return parameters;
}

function makePageList(behaviors) {
	var batch = new BatchModel(0, -1, -1, behaviors);
	var batchList = new Array();
	batchList.push(batch);
	var page = new PageModel(batchList);
	pageList.push(page);
}

function submitScriptByAjax(scriptModel) {
	var formData = new FormData();
	var filesDiv = $("input[type=file]");
	console.log(filesDiv);
	if (filesDiv.length != 0) {
		for ( var i = 0; i < filesDiv.length; i++) {
			formData.append("paramFiles", filesDiv[i].files[0],
					filesDiv[i].files[0].name);
		}

	}

	formData.append("content", JSON.stringify(scriptModel));

	$.ajax({
		url : "uploadScript",
		type : "POST",
		contentType : false,
		processData : false,
		data : formData,
		success : function(data) {
			information("upload success");
			window.location.replace("script.jsp");
		}
	});
}

function submitScriptWithScriptName(scriptName) {
	if (scriptName == null || scriptName == "") {
		information("Please input scriptName.");
		return;
	}
	if (behaviors.length == 0) {
		information("Please save the behavior or fill in the form.");
		return;
	} else {
		var n = behaviors.length;
		information("you have save " + n + " behaviors");
	}
	makePageList(behaviors);
	var runScenarioModel = new RunScenarioModel(0, usePluginList, null,
			pageList);
	var scriptModel = new ScenarioModel(scriptName, runScenarioModel);
	submitScriptByAjax(scriptModel);
}
